Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util.concurrent
Class AbstractExecutorService

    java.lang.Object
      java.util.concurrent.AbstractExecutorService

All Implemented Interfaces:
  Executor, ExecutorService

Direct Known Subclasses:
  ThreadPoolExecutor

    public abstract class AbstractExecutorService

extends Object
implements ExecutorService

Provides default implementation of `ExecutorService` execution methods. This class implements the `submit`, `invokeAny` and `invokeAll` methods using the default `FutureTask` class provided in this package. For example, the implementation of `submit(Runnable)` creates an associated `FutureTask` that is executed and returned. Subclasses overriding these methods to use different `Future` implementations should do so consistently for each of these methods.

Since:
  1.5

Constructor Summary
`AbstractExecutorService()`

Method Summary
`
`<T> List<Future<T>>`
` | `invokeAll(Collection<Callable<T>> tasks)` Executes the given tasks, returning a list of Futures holding their status and results when all complete.
`
`<T> List<Future<T>>`
` | `invokeAll(Collection<Callable<T>> tasks, long timeout, TimeUnit unit)` Executes the given tasks, returning a list of Futures holding their status and results when all complete or the timeout expires, whichever happens first.
`
`<T> T`
` | `invokeAny(Collection<Callable<T>> tasks)` Executes the given tasks, returning the result of one that has completed successfully (i.e., without throwing an exception), if any do.
`
`<T> T`
` | `invokeAny(Collection<Callable<T>> tasks, long timeout, TimeUnit unit)` Executes the given tasks, returning the result of one that has completed successfully (i.e., without throwing an exception), if any do before the given timeout elapses.
`
`<T> Future<T>`
` | `submit(Callable<T> task)` Submits a value-returning task for execution and returns a Future representing the pending results of the task.
`Future<?>` | `submit(Runnable task)` Submits a Runnable task for execution and returns a Future representing that task.
`
`<T> Future<T>`
` | `submit(Runnable task, T result)` Submits a Runnable task for execution and returns a Future representing that task that will upon completion return the given result

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.util.concurrent.ExecutorService
`awaitTermination, isShutdown, isTerminated, shutdown, shutdownNow`

Methods inherited from interface java.util.concurrent.Executor
`execute`

Constructor Detail

### AbstractExecutorService

    public AbstractExecutorService()

Method Detail

### submit

    public Future<?> submit(Runnable task)

  Description copied from interface: `ExecutorService`
  Submits a Runnable task for execution and returns a Future representing that task.

  Specified by:
    `submit` in interface `ExecutorService`
  Parameters:
    `task` - the task to submit
  Returns:
    a Future representing pending completion of the task, and whose `get()` method will return `null` upon completion.

### submit

    public <T> Future<T> submit(Runnable task,
                                T result)

  Description copied from interface: `ExecutorService`
  Submits a Runnable task for execution and returns a Future representing that task that will upon completion return the given result

  Specified by:
    `submit` in interface `ExecutorService`
  Parameters:
    `task` - the task to submit
    `result` - the result to return
  Returns:
    a Future representing pending completion of the task, and whose `get()` method will return the given result upon completion.

### submit

    public <T> Future<T> submit(Callable<T> task)

  Description copied from interface: `ExecutorService`
  Submits a value-returning task for execution and returns a Future representing the pending results of the task.

  If you would like to immediately block waiting for a task, you can use constructions of the form `result = exec.submit(aCallable).get();`

  Note: The `Executors` class includes a set of methods that can convert some other common closure-like objects, for example, `PrivilegedAction` to `Callable` form so they can be submitted.

  Specified by:
    `submit` in interface `ExecutorService`
  Parameters:
    `task` - the task to submit
  Returns:
    a Future representing pending completion of the task

### invokeAny

    public <T> T invokeAny(Collection<Callable<T>> tasks)
                throws InterruptedException,
                       ExecutionException

  Description copied from interface: `ExecutorService`
  Executes the given tasks, returning the result of one that has completed successfully (i.e., without throwing an exception), if any do. Upon normal or exceptional return, tasks that have not completed are cancelled. The results of this method are undefined if the given collection is modified while this operation is in progress.

  Specified by:
    `invokeAny` in interface `ExecutorService`
  Parameters:
    `tasks` - the collection of tasks
  Returns:
    The result returned by one of the tasks.
  Throws:
    `InterruptedException` - if interrupted while waiting
    `ExecutionException` - if no task successfully completes

### invokeAny

    public <T> T invokeAny(Collection<Callable<T>> tasks,
                           long timeout,
                           TimeUnit unit)
                throws InterruptedException,
                       ExecutionException,
                       TimeoutException

  Description copied from interface: `ExecutorService`
  Executes the given tasks, returning the result of one that has completed successfully (i.e., without throwing an exception), if any do before the given timeout elapses. Upon normal or exceptional return, tasks that have not completed are cancelled. The results of this method are undefined if the given collection is modified while this operation is in progress.

  Specified by:
    `invokeAny` in interface `ExecutorService`
  Parameters:
    `tasks` - the collection of tasks
    `timeout` - the maximum time to wait
    `unit` - the time unit of the timeout argument
  Returns:
    The result returned by one of the tasks.
  Throws:
    `InterruptedException` - if interrupted while waiting
    `ExecutionException` - if no task successfully completes
    `TimeoutException` - if the given timeout elapses before any task successfully completes

### invokeAll

    public <T> List<Future<T>> invokeAll(Collection<Callable<T>> tasks)
                              throws InterruptedException

  Description copied from interface: `ExecutorService`
  Executes the given tasks, returning a list of Futures holding their status and results when all complete. `Future.isDone()` is `true` for each element of the returned list. Note that a completed task could have terminated either normally or by throwing an exception. The results of this method are undefined if the given collection is modified while this operation is in progress.

  Specified by:
    `invokeAll` in interface `ExecutorService`
  Parameters:
    `tasks` - the collection of tasks
  Returns:
    A list of Futures representing the tasks, in the same sequential order as produced by the iterator for the given task list, each of which has completed.
  Throws:
    `InterruptedException` - if interrupted while waiting, in which case unfinished tasks are cancelled.

### invokeAll

    public <T> List<Future<T>> invokeAll(Collection<Callable<T>> tasks,
                                         long timeout,
                                         TimeUnit unit)
                              throws InterruptedException

  Description copied from interface: `ExecutorService`
  Executes the given tasks, returning a list of Futures holding their status and results when all complete or the timeout expires, whichever happens first. `Future.isDone()` is `true` for each element of the returned list. Upon return, tasks that have not completed are cancelled. Note that a completed task could have terminated either normally or by throwing an exception. The results of this method are undefined if the given collection is modified while this operation is in progress.

  Specified by:
    `invokeAll` in interface `ExecutorService`
  Parameters:
    `tasks` - the collection of tasks
    `timeout` - the maximum time to wait
    `unit` - the time unit of the timeout argument
  Returns:
    A list of Futures representing the tasks, in the same sequential order as produced by the iterator for the given task list. If the operation did not time out, each task will have completed. If it did time out, some of these tasks will not have completed.
  Throws:
    `InterruptedException` - if interrupted while waiting, in which case unfinished tasks are cancelled.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.